import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { RechargeOrder, RechargeOrderParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询会员充值订单表
 */
export async function pageRechargeOrder(params: RechargeOrderParam) {
  const res = await request.get<ApiResult<PageResult<RechargeOrder>>>(
    MODULES_API_URL + '/shop/recharge-order/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询会员充值订单表列表
 */
export async function listRechargeOrder(params?: RechargeOrderParam) {
  const res = await request.get<ApiResult<RechargeOrder[]>>(
    MODULES_API_URL + '/shop/recharge-order',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加会员充值订单表
 */
export async function addRechargeOrder(data: RechargeOrder) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/recharge-order',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改会员充值订单表
 */
export async function updateRechargeOrder(data: RechargeOrder) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/recharge-order',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除会员充值订单表
 */
export async function removeRechargeOrder(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/recharge-order/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除会员充值订单表
 */
export async function removeBatchRechargeOrder(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/recharge-order/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询会员充值订单表
 */
export async function getRechargeOrder(id: number) {
  const res = await request.get<ApiResult<RechargeOrder>>(
    MODULES_API_URL + '/shop/recharge-order/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
